package org.jpn.xucker.perl;

import java.io.File;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Properties;

import org.eclipse.jface.wizard.Wizard;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.DropTargetListener;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * @author ak
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class PerlPathWizard {
	private Hashtable descriptionHash = new Hashtable();
	public static void main(String[] args) {
		new PerlPathWizard();
	}

	public PerlPathWizard() {
		Display display = new Display();

		WizardDialog dialog =
			new WizardDialog(new Shell(display), new MyWizard());
		int result = dialog.open();
		System.out.println(result);
	}

	

	public class MyWizard extends Wizard {
		FileOpenDir fileOpenPage;
		PerlPathPage perlPathPage;
		public MyWizard() {
			super();
			this.setWindowTitle("Perl pX̕ύX");
			fileOpenPage = new FileOpenDir("t@C");
			
			addPage(fileOpenPage);
			perlPathPage = new PerlPathPage("ۑ");

			//
			addPage(perlPathPage);
			
		}

		

		public boolean isValidPath(String path) {
			if (path != null && path.length() > 0) {
				return true;
			} else
				return false;
		}
		public boolean canFinish() {
			if (fileOpenPage == null || perlPathPage == null)
				return false;

			return isValidPath(fileOpenPage.getFilePath())
				&& isValidPath(perlPathPage.getPerlPath());
		}

		public boolean performFinish() {
			exec(fileOpenPage.getFilePath(), "#!" + perlPathPage.getPerlPath());
			MessageBox box =
				new MessageBox(Display.getCurrent().getShells()[0]);
			box.setMessage(
				"s\n"
					+ fileOpenPage.getFilePath()
					+ "\n"
					+ perlPathPage.getPerlPath());
			box.open();
			return true;
		}

		public void exec(String inputdir, String outputdir) {

			PerlPathChange perlPathChange =
				new PerlPathChange(inputdir, outputdir);
				perlPathChange.execute();

		}

		public void flatFile(File file, String outputdir) {
			if (file.isDirectory()) {
				String files[] = file.list();
				for (int i = 0; i < files.length; i++) {
					flatFile(new File(file, files[i]), outputdir);
				}

			} else {
				File newFile = new File(outputdir, file.getName());
				if (newFile.exists()) {
					existSameFile(file);
				} else {
					file.renameTo(newFile);
				}
			}

		}

		
		private void existSameFile(File file) {
			System.out.println("do nothing:"+file.getAbsolutePath());
		}

	}
	public class FileOpenDir extends WizardPage implements SelectionListener {

		private Text textField;

		/**
				 * @param pageName
				 */
		protected FileOpenDir(String pageName) {
			super(pageName);
			setTitle(pageName);
			setDescription("ǂݍރt@C");
		}

		/**
		* @param fileSavePage
		*/

		/* (non-Javadoc)
				 * @see org.eclipse.jface.dialogs.DialogPage#createControl(org.eclipse.swt.widgets.Composite)
				 */

		public void addDropFile(Text composite, DropTargetListener listener) {
			Transfer[] types = new Transfer[] { FileTransfer.getInstance()};

			int operations = DND.DROP_MOVE | DND.DROP_COPY;

			DropTarget target2 = new DropTarget(composite, operations);
			target2.setTransfer(types);

			target2.addDropListener(listener);

		}
		public void createControl(Composite arg0) {

			if (arg0 != null) {
				Canvas group = new Canvas(arg0, SWT.NONE);
				group.setLayout(new FillLayout(SWT.VERTICAL));
				textField = new Text(group, SWT.BORDER | SWT.SINGLE);

				addDropFile(textField, new DropMonitor(textField));

				Canvas group2 = new Canvas(group, SWT.NONE);

				Button choice = new Button(group2, SWT.NONE);
				choice.setBounds(0, 0, 100, 20);
				choice.addSelectionListener(this);
				choice.setText("t@CI");
				setControl(group);
			}

		}

		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		public void widgetSelected(SelectionEvent e) {

			DirectoryDialog dialog = new DirectoryDialog(this.getShell());
			String path = dialog.open();
			if (path != null) {
				textField.setText(path);
				
			} else
				textField.setText("");

			this.getContainer().updateButtons();

		}

		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		public void widgetDefaultSelected(SelectionEvent e) {

		}

		public String getFilePath() {
			if (textField == null)
				return null;
			else
				return textField.getText();
		}

	}
	public class DropMonitor extends DropTargetAdapter {
		private Text text;
		public DropMonitor(Text text) {
			this.text = text;
		}
		public void drop(DropTargetEvent event) {
			String files[] = (String[]) event.data;
			
			for (int i = 0; i < files.length; i++) {
				text.setText(files[i]);
			}

		}
	}
	public class PerlPathPage extends WizardPage implements SelectionListener {

		private Combo perlPathSelect;

		/**
				 * @param pageName
				 */
		protected PerlPathPage(String pageName) {

			super(pageName);

		}

		/**
		* @param path
		*/

		/* (non-Javadoc)
				 * @see org.eclipse.jface.dialogs.DialogPage#createControl(org.eclipse.swt.widgets.Composite)
				 */
		public void createControl(Composite arg0) {

			if (arg0 != null) {
				Canvas group = new Canvas(arg0, SWT.NONE);
				group.setLayout(new FillLayout(SWT.VERTICAL));

				perlPathSelect = new Combo(group, SWT.DROP_DOWN);
				Properties properties = new Properties();
				try {
					properties.load(
						this.getClass().getResourceAsStream(
							"/org/jpn/xucker/perl/perlpath.properties"));
					int index = 1;
					while (true) {
						String value =
							properties.getProperty("perl.path" + index);
						if (value == null)
							break;
						else {
							perlPathSelect.add(value);
							String description =
								properties.getProperty(
									"perl.description" + index);
							if (description == null)
								description = "";
							descriptionHash.put(value, description);
						}
						index++;
					}
				} catch (IOException e) {
					// TODO ꂽ catch ubN
					e.printStackTrace();
				}

				perlPathSelect.select(0); // ŏ̃ACeIԂɂ
				perlPathSelect.addSelectionListener(this);

				setControl(group);

				String value =
					perlPathSelect.getItem(perlPathSelect.getSelectionIndex());
				this.setDescription((String) descriptionHash.get(value));

			}

		}

		public String getPerlPath() {
			return perlPathSelect.getItem(perlPathSelect.getSelectionIndex());

		}


		/* ( Javadoc)
		 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		public void widgetSelected(SelectionEvent arg0) {
			Object obj = arg0.getSource();
			if (obj instanceof Combo) {
				Combo combo = (Combo) obj;
				String value = combo.getItem(combo.getSelectionIndex());
				this.setDescription((String) descriptionHash.get(value));
			}

		}

		/* ( Javadoc)
		 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		public void widgetDefaultSelected(SelectionEvent arg0) {
			// TODO ꂽ\bhEX^u

		}

	}
	public class MyWizardPage extends WizardPage {

		/**
		 * @param pageName
		 */
		protected MyWizardPage(String pageName) {
			super(pageName);

		}

		/* (non-Javadoc)
		 * @see org.eclipse.jface.dialogs.DialogPage#createControl(org.eclipse.swt.widgets.Composite)
		 */
		public void createControl(Composite arg0) {

			if (arg0 != null) {
				Label label = new Label(arg0, SWT.NONE);
				label.setText(this.getName());
				setControl(label);
			}

		}

	}

}
